/*                     		    BigListDemo									*/
/*					* Lis tManager demonstration program *						*/
/*								  Volume 2									*/

/*		Copyright  1988 by David A. Surovell & Small Systems Guild.		*/
/*							All rights reserved.							*/

/*				Written to compile under Aztec C version 1.06h 				*/
/*					and under LightspeedC version 3.13						*/

#include	<VellLibHeaders.h>

#define		DEMOresFName1	"\PListMgrDemo.rsrc"
#define		DEMOresFName2	"\PTestPicts.rsrc"

#define		TEXTcellH		150
#define 	TEXTcellV		16

#define		COLcount		10
#define		ROWcount		10

#define		MENUconfig		25
#define		MENUdrawl		26
#define		MENUselect		27

#define		PICTfirstid		200
#define		ICONfirstid		12350
#define		PATTfirstid		12350

#define		DLOGselector	12360
#define		DLOGconfig		12361
#define		DLOGcSize		12362

#define		LDEFpict		256
#define		LDEFpat			257
#define		LDEFicon		258


EventRecord		event;						/* Main Event loop record */
EventStuff		whatHappened;				/* Main Event loop detail record */
WindowRecord	theWR;						/* demo window record */
WindowPtr		theWP = NULL;				/* demo window pointer */
Rect			wRect;      				/* demo window rectangle */
MenuHandle		appleMenu,fileMenu,editMenu;/* standard menu handles */
MenuHandle		CMenu,DMenu,SMenu;			/* List Manager Demo menu handles */
Handle			dummyH;						/* used for resource presence check */
int				fRefNum1 = -1,fRefNum2 = -1;/* resource file access tokens */

ListHandle		theList = NULL;
Rect			lvRect,dBounds;      		/* theList: viewRect, dataBounds, drawFrame */
Point			lOffset,cSize;      		/* theList: offset in window, cellSize */
Boolean			a2click;

char			*dummyStr = " - ";

Boolean			SelectLDemo(),LMShowConfig(),LDSetCSize();
void			InitLDMenus(),InitLD1(),InitLD2(),InitLD3(),InitLD4();
void			DoCmenu(),DoDmenu(),DoSmenu();


main()
{
	XTendInit();                                /* Extender initialization routine  */
	StdMenus(&appleMenu,&fileMenu,&editMenu);   /* set up standard menus */
	SetMenuItem(appleMenu,1,"\PAbout ListDemo...");
	DisableItem(appleMenu,1);					/* no "About" dialog implemented */
	InitLDMenus();								/* set up List Demo menus */

	fRefNum1 = -1;								/* rsrcs already in the resource fork */
	fRefNum2 = -1;

#ifdef TESTING
	fRefNum1 = OpenResFile(DEMOresFName1);		/* load Volume 2 demo resources */
	dummyH = GetResource('DLOG',DLOGselector);
	if ((fRefNum1 < 0) && (ResError() != noErr)) {	/* quit if not found */
		BugAlert("\PError: ","\Pcan't find the demo resources!","\P","\P");
		return(-1);
	}
	fRefNum2 = OpenResFile(DEMOresFName2);
	dummyH = GetResource('PICT',PICTfirstid);
	if ((fRefNum2 < 0) && (ResError() != noErr))
		BugAlert("\PError: ","\Pcan't find PICT resources!","\P","\P");
#endif

	do {
		do {
			SystemTask();
		} while (!XTGetNextEvent(everyEvent,&event));

		HandleEvent(&event,&whatHappened);

		switch (whatHappened.MenuNum) {
			case MENUconfig:	DoCmenu(whatHappened.ItemNum);	break;
			case MENUdrawl:		DoDmenu(whatHappened.ItemNum);	break;
			case MENUselect:	DoSmenu(whatHappened.ItemNum);	break;
			default:			break;
		}

	} while (!ExitRequest(&whatHappened));

	if (fRefNum1 >= 0)
		CloseResFile(fRefNum1);
	if (fRefNum2 >= 0)
		CloseResFile(fRefNum2);
}


void InitLD1()
{
	Cell	tCell;
	int		i;

	SetRect(&wRect,50,50,480,200);					/* init ListDemo1 window */
	theWP = CreateWindow(&theWR,&wRect,"\PListDemo1",1,
						FALSE,FALSE,FALSE,FALSE,FALSE);

	SetRect(&lvRect,20,20,400,84);					/* list local display rect */
	SetRect(&dBounds,0,0,COLcount,ROWcount);		/* list row & column dimensions */
	SetPt(&cSize,0,0);								/* let List Manager pick cell dimensions */

	theList = LNew(&lvRect,&dBounds,pass(cSize),0,	/* use the standard (text) LDEF: 0 */
					theWP,FALSE,FALSE,FALSE,FALSE);
	(**theList).selFlags = 0;						/* default selection method */
	(**theList).vScroll = NULL;						/* so we can verify later that... */
	(**theList).hScroll = NULL;						/* ...this list doesn't scroll... */
	(**theList).listFlags = lDoVAutoScroll;			/* ...but allow vertical autoscroll */

	for (i=0; i<(COLcount*ROWcount); i++) {			/* init Cell data */
		dummyStr[0] = '0' + (i / COLcount);
		dummyStr[2] = 'A' + (i % COLcount);
		SetPt(&tCell,i % COLcount,i / COLcount);
		LSetCell(dummyStr,3,pass(tCell),theList);
	}
	LDoDraw(TRUE,theList);

	SetWList(theWP,theList);						/* make it an Extender list */
	ShowWindow(theWP);
}


void InitLD2()
{
	SFReply		theReply;
	int			count, total;

	SetRect(&wRect,50,50,420,190);
	theWP = CreateWindow(&theWR,&wRect,"\PListDemo2",1,
						FALSE,FALSE,FALSE,FALSE,FALSE);

	SetPt(&cSize,70,50);									/* Cells will be 50 by 70 pixels */
	SetRect(&dBounds,0,0,COLcount,ROWcount);
	SetRect(&lvRect,0,0,350,50*2);							/* ViewRect of list */
	OffsetRect(&lvRect,10,10);

	theList = LNew(&lvRect,&dBounds,pass(cSize),LDEFpat,theWP,
				FALSE,FALSE,TRUE,FALSE);
	(void)SetXTCtlException((**theList).hScroll,TRUE);

	total = 38;
	count = LMIndResLoad(theList,'PAT#',PATTfirstid,total);	/* load available PICTs into the list */
	if (count < 0) {
		BugAlert("\PError: ","\Pcan't load any PAT# resources!","\P","\P");
		RETURN;
	}

	SetWList(theWP,theList);							/* make it an Extender list */
	ShowWindow(theWP);
}


void InitLD3()
{
	int			count,total,firstID;
	Boolean		stat;

	SetRect(&wRect,150,50,260,190);							/* init ListDemo3 window */
	theWP = CreateWindow(&theWR,&wRect,"\PListDemo3",1,
						FALSE,FALSE,FALSE,FALSE,FALSE);

	SetPt(&cSize,32,32);									/* assign the list dimension variables */
	SetRect(&dBounds,0,0,2,6);								/* 2 columns x 6 rows */
	SetRect(&lvRect,0,0,32*2,32*4);							/* viewRect = cellSize x cellCount */
	OffsetRect(&lvRect,10,10);								/* topLeft: local to the window */

	theList = LNew(&lvRect,&dBounds,pass(cSize),LDEFicon,	/* create the list */
					theWP,FALSE,FALSE,FALSE,TRUE);
	(**theList).selFlags = lOnlyOne | lNoNilHilite;			/* selection mode: only one, no empty cell selects */
	(**theList).hScroll = NULL;								/* enable Extender scrollBar presense check */
	(void)SetXTCtlException((**theList).vScroll,TRUE);		/* don't let HandleEvent() handle this! */

	total = 12;
	firstID = ICONfirstid;
	count = LMIconLoad(theList,total,firstID);				/* load available icons into the list */
	if (count <= 0) {
		SysBeep(50);
		RETURN;
	}

	SetWList(theWP,theList);								/* make it an Extender list */
	ShowWindow(theWP);
}


void InitLD4()
{
	int			count,total,firstID;
	Boolean		stat;

	SetRect(&wRect,50,50,440,320);							/* init ListDemo4 window */
	theWP = CreateWindow(&theWR,&wRect,"\PListDemo4",1,
						FALSE,FALSE,FALSE,FALSE,FALSE);

	SetPt(&cSize,70,50);									/* assign the list dimension variables */
	SetRect(&dBounds,0,0,5,2);								/* 5 columns x 2 rows */
	SetRect(&lvRect,0,0,70*5,50*2);							/* viewRect = cellSize x cellCount */
	OffsetRect(&lvRect,10,10);								/* topLeft: local to the window */

	theList = LNew(&lvRect,&dBounds,pass(cSize),LDEFpict,	/* create the list */
					theWP,FALSE,FALSE,TRUE,TRUE);
	(**theList).selFlags = lOnlyOne | lNoNilHilite;			/* selection mode: only one, no empty cell selects */
	SetXTCtlException((**theList).hScroll,TRUE);			/* don't let HandleEvent() handle this! */
	SetXTCtlException((**theList).vScroll,TRUE);			/* don't let HandleEvent() handle this! */

	total = 10;
	firstID = PICTfirstid;
	count = LMResLoad(theList,'PICT',total,firstID);		/* load available icons into the list */
	if (count <= 0) {
		SysBeep(50);
		RETURN;
	}

	SetWList(theWP,theList);								/* make it an Extender list */
	ShowWindow(theWP);
}


void InitLDMenus()
{
	CMenu = BuildMenu(MENUconfig,"\PConfigure",
				"\PSelect list/1;(Show config/2;(Set cell size/3");
	DMenu = BuildMenu(MENUdrawl,"\PDraw",
				"\PActivate/4;Deactivate/5;Select next/6;Select prior/7;Deselect all/8;Show select/9;Draw list/0");
	SMenu = BuildMenu(MENUselect,"\PSelectMode",
		"\PNo empty select;SHIFT sensing;No rect extend;SHIFT extending;No disjoint;SHIFT drag;Only one;DEFAULT");
	EnableAllItems(DMenu,FALSE);
	EnableAllItems(SMenu,FALSE);
	SetItemMark(SMenu,7,diamondMark);			
}


Boolean SelectLDemo(demoType)
int		*demoType;
{
	DialogPtr	DP;
	int 		oldButton,currButton;

	DP = GetNewDialog(DLOGselector,NULL,NEG_ONE);
	ShowWindow(DP);
	FrameDItem(DP,1);
	CheckDItem(DP,4);

	*demoType = 1;
	oldButton = 4;

	do {
		ModalDialog(NULL,&currButton);

		switch (currButton) {
			case 4:
			case 5:
			case 6:
			case 7:		*demoType = currButton - 3;
						CheckDItem(DP,currButton);
						if (oldButton != currButton)
							CheckDItem(DP,oldButton);
						break;
			default:	break;
		}
		oldButton = currButton;
	} while ((currButton != 1) && (currButton != 2));

	DisposDialog(DP);

	if (currButton == 1) {
		EnableItem(CMenu,2);
		EnableItem(CMenu,3);
		EnableAllItems(DMenu,TRUE);
		EnableAllItems(SMenu,TRUE);
		return(TRUE);
	}
	else 
		return(FALSE);
}


Boolean LMShowConfig(anLH)
ListHandle	anLH;
{
	DialogPtr	DP;
	Cell		firstZero;
	int 		cols,rows,cellH,cellV,nzCells,itemHit;

	if (anLH == NULL)
		return(FALSE);

	DP = GetNewDialog(DLOGconfig,NULL,NEG_ONE);		/* declared as invisible */

	cols = (**anLH).dataBounds.right;				/* determine the configuration */
	rows = (**anLH).dataBounds.bottom;
	cellH = (**anLH).cellSize.h;
	cellV = (**anLH).cellSize.v;
	nzCells = LMCountCells(anLH,&firstZero);

	PutDNum(DP,7,(long)cols);						/* set the appropriate dialog items */
	PutDNum(DP,6,(long)rows);						/* ...to their calculated values */
	PutDNum(DP,11,(long)cellH);
	PutDNum(DP,12,(long)cellV);
	PutDNum(DP,14,(long)nzCells);

	ShowWindow(DP);
	FrameDItem(DP,1);

	itemHit = -1;
	while (itemHit != 1)
		ModalDialog(NULL,&itemHit);

	DisposDialog(DP);

	return(TRUE);
}


Boolean LDSetCSize(aCSize)							/* set cell size: (100,160) max */
Cell	*aCSize;
{
	DialogPtr	DP;
	long 		cellH,cellV;
	int 		itemHit;

	DP = GetNewDialog(DLOGcSize,NULL,NEG_ONE);		/* declared as invisible */

	cellH = (**theList).cellSize.h;
	cellV = (**theList).cellSize.v;

	PutDNum(DP,6,cellH);
	PutDNum(DP,7,cellV);

	ShowWindow(DP);
	FrameDItem(DP,1);

	itemHit = -1;
	while ((itemHit != 1) && (itemHit != 2))
		ModalDialog(NULL,&itemHit);

	GetDNum(DP,6,&cellH);							/* test size "validity" */
	GetDNum(DP,7,&cellV);
	if ((cellH <= 0) || (cellH > 250) || (cellV <= 0) || (cellV > 250))
		itemHit = 2;

	DisposDialog(DP);

	if (itemHit == 1) {								/* set the input argument */
		aCSize->h = cellH;
		aCSize->v = cellV;	
		return(TRUE);
	}
	else {
		SysBeep(5);
		return(FALSE);
	}
}


void DoCmenu(iNum)
int		iNum;
{
	int		whichDemo;

	switch (iNum) {		/* Configuration menu */
	  case 1: 
		if (SelectLDemo(&whichDemo) == TRUE) {
			if (ValidPointer((Ptr)theWP))
				KillWindow(theWP);
			switch (whichDemo) {
				case 1:		InitLD1();	break;
				case 2:		InitLD2();	break;
				case 3:		InitLD3();	break;
				case 4:		InitLD4();	break;
				default:	break;
			}
		}
		break;

	  case 2:
		LMShowConfig(theList);
		break;

	  case 3: 
		if (LDSetCSize(&cSize) == TRUE) {
			LCellSize(pass(cSize),theList);
			EraseRect(&((**theList).rView));
			InvalRect(&((**theList).rView));
		}
		break;
	}

}


void DoDmenu(iNum)
int		iNum;
{
	Cell	tCell;

	if (theList == NULL)
		RETURN;

	switch (iNum) {		/* Drawing menu */
	  case 1: 
		LMActivate((Handle)theList);
		break;

	  case 2: 
		LMDeactivate((Handle)theList);
		break;

	  case 3: 
		LMNextSelect(theList);
		break;

	  case 4: 
		LMPriorSelect(theList);
		break;

	  case 5: 
		SetPt(&tCell,0,0);
		while (LGetSelect(TRUE,&tCell,theList) == TRUE)
			LSetSelect(FALSE,pass(tCell),theList);
		break;

	  case 6:
		LAutoScroll(theList);
		break;

	  case 7:
		LMListDraw(theList);
		break;
	}

}


void DoSmenu(iNum)
int		iNum;
{
	int		markVal,i;

	switch (iNum) {		/* Selection menu */
	  case 1:	(**theList).selFlags ^= lNoNilHilite;	break;
	  case 2:	(**theList).selFlags ^= lUseSense;		break;
	  case 3:	(**theList).selFlags ^= lNoRect;		break;
	  case 4:	(**theList).selFlags ^= lNoExtend;		break;
	  case 5:	(**theList).selFlags ^= lNoDisjoint;	break;
	  case 6:	(**theList).selFlags ^= lExtendDrag;	break;
	  case 7:	(**theList).selFlags ^= lOnlyOne;		break;
	  case 8:	(**theList).selFlags =  0;				break;
	}

	if ((iNum == 8) || !((**theList).selFlags)) {
		for (i=1; i<=7; i++)
			SetItemMark(SMenu,i,noMark);
		SetItemMark(SMenu,8,diamondMark);
	}
	else {
		GetItemMark(SMenu,iNum,&markVal);
		markVal = ((markVal != noMark) ? noMark : diamondMark);
		SetItemMark(SMenu,iNum,markVal);
		SetItemMark(SMenu,8,noMark);
	}
}

