/*						* Commlib library header *							*/
/*						  ssg Commlib										*/

/*		Copyright  1986,87 by small systems guild.  All rights reserved.	*/

/*				Written to compile under Aztec C version 1.06h 				*/
/*					and under Lightspeed C version 2.01						*/

#define		COMMEXTCMDS				/* file has already been included flag	*/

				/* terminal management command sequences	*/
				
#define		reset		100			/* reset terminal to default status/mode*/	
#define		status		101			/* query terminal status/mode/condition	*/	
#define		rptStatus	102			/* report term status/mode/condition	*/	
#define		askID		103			/* query terminal type/mode/identity	*/	
#define		rptID		104			/* report terminal type/mode/identity	*/	
#define		diag_1		111			/* term internal diagnostic test one	(##)*/	
#define		diag_2		112			/* term internal diagnostic test two	(##)*/	
#define		diag_3		113			/* term internal diagnostic test three	(##)*/	
#define		diag_4		114			/* term internal diagnostic test four	(##)*/	

				/* cursor positioning command sequences		*/
				
#define		cursHome	200			/* move cursor to home command sequence	*/	
#define		cursUp		201			/* cursor up one row command sequence	*/	
#define		cursDown	202			/* cursor down one row command sequence	*/	
#define		cursRight	203			/* cursor right one col command sequence*/	
#define		cursLeft	204			/* cursor left one col command sequence	*/	
#define		nextRow		210			/* cursor move to next available row	(##)*/	
#define		nextCol		211			/* cursor move to next available col	(##)*/	
#define		prevRow		212			/* cursor move to previous available row(##)*/	
#define		prevCol		213			/* cursor move to previous available col(##)*/	
#define		cursXY		220			/* query cursor row/column position std	*/	
#define		rptCXY		221			/* report cursor row/column position std*/	
#define		gotoXY		222			/* direct cursor addressing sequence std*/	
#define		cursIdx		223			/* cursor move relative row index		(##)*/	
#define		cursRIdx	224			/* cursor move reverse relative row idx	(##)*/	
#define		cursSave	225			/* save cursor position and attributes	*/	
#define		cursRestore	226			/* restore cursor position & attributes	*/	

				/* screen erase by area command sequences	*/
				
#define		clrCEOL		300			/* erase from cursor pos to end of line	*/	
#define		clrBCurs	301			/* erase from line beginning to cursor	*/	
#define		clrCRow		302			/* erase entire line cursor currently on*/	
#define		clrCEOScr	303			/* erase from cursor to end of screen	*/	
#define		clrScrCurs	304			/* erase from start of screen to cursor	*/	
#define		clrScreen	305			/* erase all rows & columns on screen	*/	
#define		clrScrFill	306			/* erase entire screen w/fill character	*/	

				/* line & page insert & delete command seq	*/
				
#define		insRow		400			/* insert new row after cursor position	*/	
#define		insIdxRow	401			/* insert new row after specified row	*/	
#define		delRow		402			/* delete row cursor is currently on	*/	
#define		delIdxRow	403			/* delete specified row, update screen	*/	
#define		insPage		410			/* insert new page after cursor position*/	
#define		insIdxPage	411			/* insert new page after specified page	*/	
#define		delPage		412			/* delete page cursor is currently on	*/	
#define		delIdxPage	413			/* delete specified page, update screen	*/	
#define		showPage	414			/* display page cursor is currently on	*/	
#define		showIdxPage	415			/* display specified page, update screen*/	

				/* cursor mode control command sequences	*/
				
#define		keyUp		500			/* term arrow up key pressed sequence	*/	
#define		keyDown		501			/* term arrow down key pressed sequence	*/	
#define		keyRight	502			/* term arrow right key pressed sequence*/	
#define		keyLeft		503			/* term arrow left key pressed sequence	*/	
#define		keyHome		504			/* term home cursor key pressed sequence*/	
#define		setCRLF		510			/* send line feed after carriage return	*/	
#define		noCRLF		511			/* no line feed after carriage return	*/	
#define		autoRepeat	520			/* enable autorepeat when key held down	*/	
#define		noRepeat	521			/* disable autorept when key held down	*/	
#define		setTab		550			/* set tab stop at current column 		(##)*/	
#define		clrTab		551			/* clear tab stop at current column 	(##)*/	
#define		setHTab		552			/* set tab stop at specified column 	(##)*/	
#define		clrHTab		553			/* clear tab stop at specified column 	(##)*/	
#define		setVTab		554			/* set vertical tab at specified row 	(##)*/	
#define		clrVTab		555			/* clear vertical tab at specified row 	(##)*/	
#define		clrAllTabs	556			/* clear all current tab stops 			(##)*/	

				/* special terminal mode command sequences	*/
				
#define		scroll1		600			/* scroll mode#1 - VT100: smooth scroll	(##)*/	
#define		scroll2		601			/* scroll mode#2 - VT100: sudden scroll	*/	
#define		wrapOn		610			/* automatic text wraparound to next row*/	
#define		wrapOff		611			/* no auto text wrap around to next row	*/	
#define		graphOn		620			/* enable graphic/graph char display	*/	
#define		graphOff	621			/* disable graphic/graph char display	*/	
#define		termStd		630			/* standard/default terminal emulation	*/	
#define		term1		631			/* terminal mode#1 - VT100: ANSI emulate*/	
#define		term2		632			/* terminal mode#2 - VT100: VT52 emulate*/	
#define		term3		633			/* terminal mode#3 - alternate emulation*/	
#define		term4		634			/* terminal mode#4 - alternate emulation*/	
#define		colStd		640			/* set standard col width - usually 80	*/	
#define		colAlt		641			/* set alternate col width - VT100: 132	*/	
#define		rowStd		645			/* set standard number rows - usually 24*/	
#define		rowAlt		646			/* set alternate num rows - FullPage: 60*/	
#define		scrNorm		650			/* white text display on black backgrnd	*/	
#define		scrReverse	651			/* black text display on white backgrnd	*/	
#define		stdKeyPad	660			/* standard/default num keypad mapping	*/	
#define		alt1KeyPad	661			/* alternate#1 numeric keypad mapping	(##)*/	
#define		alt2KeyPad	662			/* alternate#2 numeric keypad mapping	(##)*/	
#define		alt3KeyPad	663			/* alternate#3 numeric keypad mapping	(##)*/	
#define		appArrows	670			/* program specific arrow key mapping	(##)*/	
#define		stdArrows	671			/* standard terminal arrow key mapping	*/	
#define		onMonitor	680			/* enable local command echo monitoring	(##)*/	
#define		offMonitor	681			/* disable local command echo monitoring*/	
#define		origin		690			/* relative/absolute screen coordinates	(##)*/	

			/* smart terminal editing and multiple page commands	*/
				
#define		editRemote	700			/* norm/default terminal editing mode	(##)*/	
#define		editLocal	701			/* enable local terminal editing mode	(##)*/	
#define		onPageEdit	702			/* enable term full page editing mode	(##)*/	
#define		offpageEdit	703			/* disable term full page editing mode	(##)*/	
#define		onLineEdit	704			/* enable term full page editing mode	(##)*/	
#define		offLineEdit	705			/* disable term full page editing mode	(##)*/	

			/* alternate terminal command sequences	(seldom used)	*/
				
#define		altStatus	900			/* alt query term status/mode/condition	*/	
#define		altRptStat	901			/* alt report term status/mode/condit.	*/	
#define		altAskID	902			/* alt query term type/mode/identity	*/	
#define		altRptID	903			/* alt report term type/mode/identity	*/	
#define		altCursXY	910			/* alt query cursor row/column position	*/	
#define		altRptCXY	911			/* alt report cursor row/column position*/	
#define		altGotoXY	912			/* alt direct cursor addressing sequence*/	
#define		cltCEOL		920			/* alt erase from cursor to end of line	*/	
#define		cltBCurs	921			/* alt erase from line beginning to curs*/	
#define		cltCRow		922			/* alt erase entire line cursor is on	*/	
#define		cltCEOScr	923			/* alt erase from curs to end of screen	*/	
#define		cltScrCurs	924			/* alt erase from screen start to cursor*/	
#define		cltScreen	925			/* alt erase all rows/columns on screen	*/	
