/*						* Commlib library header *							*/
/*						  ssg Commlib										*/

/*		Copyright  1986,87 by small systems guild.  All rights reserved.	*/

/*				Written to compile under Aztec C version 1.06i 				*/
/*					and under Lightspeed C version 2.01						*/

#define		COMMEXTDEFS				/* file has already been included flag	*/

#ifndef 	VOLUME1					/* if <extender.h> not #included it must*/
#include	<extender.h>			/*  be included for code to compile		*/
#endif

#ifndef 	COMMEXTCMDS				/* if <extcmds.h> not #included it must	*/
#include	<extcmds.h>				/*  be included for code to compile		*/
#endif

#ifdef AZTEC

#include    <serial.h>

#endif

#ifdef LIGHTSPEED

#include	<SerialDvr.h>

#endif

#define	GetWPort(A)		((TermData *)((**((WDHandle)(((WindowPeek)A)->refCon))).rsrv2))
#define	SetWPort(A,B)	((**((WDHandle)(((WindowPeek)A)->refCon))).rsrv2 = (unsigned long)B)

#define		ONEBIT			0x01		/* mask to get first bit only   	*/
#define		TWOBITS			0x03		/* mask to get first two bits only	*/
#define		THREEBITS		0x07		/* mask to get first three bits only*/
#define		FOURBITS		0x0F		/* mask to get first four bits only	*/
#define		FIVEBITS		0x1F		/* mask to get first five bits only	*/
#define		SIXBITS			0x3F		/* mask to get first six bits only	*/
#define		SEVENBITS		0x7F		/* mask to get first seven bits only*/
#define		EIGHTBITS		0xFF		/* mask to get first eight bits only*/

#define		ETX			0x03	/* interrupt/cancel key (^C) 'End Of Trans'	*/
#define		EOT			0x04	/* unix end of file key (^D) 'End Of Tape'	*/
#define		BS			0x08	/* backspace (^H) 'cursor on position left'	*/
#define		LF			0x0A	/* linefeed character (^J) 'cursor down row'*/
#define		FF			0x0C	/* form feed (^L) 'to top of page column 0'	*/
#define		CR			0x0D	/* carriage return (^M) 'cursor to column 0'*/
#define		DC1			0x11	/* pause transmission (^Q) typically XOFF	*/
#define		DC2			0x12
#define		DC3			0x13	/* resume transmission (^S) typically XON	*/
#define		DC4			0x14
#define		SUB			0x1A	/* VMS end of file key (^Z)	var:clear scrn	*/
#define		ESC			0x1B	/* escape var:instruction, command follows	*/
#define		DEL			0x7F	/* dec 127 - ASCII delete key - var:rubout	*/

#define		STD_LEFTARROW	0x08		/* cursor left 1 char (^H)			*/
#define		TAB				0x09		/* tab key (^I)						*/
#define		LINEFEED		0x0A		/* linefeed character (^J) newline	*/
#define		STD_DOWNARROW	0x0A		/* cursor down one line (^J)		*/
#define		STD_UPARROW		0x0B		/* cursor up one line (^K)			*/
#define		STD_RIGHTARROW	0x0C		/* cursor right one char (^L)		*/
#define		BLANK			0x20		/* blank or space character			*/
#define		SPACE			0x20		/* blank or space character			*/
#define		CLEARSCREEN		0x1A		/* clr screen, home cursor VT52 etc.*/
#define		HOMECURSOR		0x0F		/* dummy placeholder for home cursor*/
#define		STD_ROWS		24			/* rows of text in std term vertical*/
#define		STD_COLS		80			/* text columns std term horizontal	*/
#define		STD_STATROWS	1			/* rows in std terminal status line	*/

#define		BAUDmenuID		20		/* StdCommMenus() baud rate/speed menuID*/
#define		PORTmenuID		21		/* StdCommMenus() commport select menuID*/
#define		PRAMmenuID		22		/* StdCommMenus() parity,stop bit menuID*/
#define		COMMmenuID		23		/* StdCommMenus() dialogs,feature menuID*/


struct SerialPort {				/* communications port parameters reference	*/
			int				refin;		
			int				refout;
			unsigned int	baud;		/* baud rate (transmission speed)	*/
			unsigned int	parity;		/* parity (odd, even, none, etc.)	*/
			unsigned int	stopbits;	/* usually one or two, end of char	*/
			unsigned int	databits;	/* must be 8 for binary file trans	*/
			char			*in;
			long			inbufsize;	/* input buffer size in bytes		*/
			char			*out;
			long			outbufsize;	/* port output buffer size in bytes	*/
		};
typedef	struct	SerialPort			SerialPort;
typedef	struct	SerialPort *		SPortPtr;
typedef struct	SerialPort **		SPortHndl;

struct TermCommand {			/* Terminal command code sequence instance	*/
		int				cmdID;			/* command type reference code ID	*/
		int				undoID;			/* cmd type ID for opposite, if any	*/
		Boolean			respond;		/* TRUE if response is expected		*/
		Boolean			synchronous;	/* TRUE if must wait for response	*/
		Boolean			onlyOnce;		/* TRUE if command not repeatable	*/
		Boolean			required;		/* TRUE if cmd must work completely	*/
		Boolean			hybrid;			/* 2-4 cmd ID refs in place of cmd	*/
										/* text. End marked 0x00 else full	*/
		Boolean			cmdRsrv1;		/* reserved for future use			*/
		Boolean			cmdRsrv2;		/* reserved for future use			*/
		Boolean			cmdRef1;		/* available for programmer use		*/
		unsigned char	text[8];		/* command code sequence characters	*/
	}; 
typedef	struct	TermCommand			TermCommand;
typedef	struct	TermCommand *		TCmdPtr;
typedef struct	TermCommand **		TCmdHndl;

struct ShortCommand {		/* communication command code sequence instance	*/
		int				cmdID;			/* command type reference code ID	*/
		int				undoID;			/* cmd type ID for opposite, if any	*/
		Boolean			respond;		/* TRUE if response is expected		*/
		Boolean			synchronous;	/* TRUE if must wait for response	*/
		Boolean			onlyOnce;		/* TRUE if command not repeatable	*/
		Boolean			required;		/* TRUE if cmd must work completely	*/
		Boolean			hybrid;			/* both cmd ID refs and chars in cmd*/
										/* text. First IDs,0x00, then chars	*/
		Boolean			cmdRsrv1;		/* reserved for future use			*/
		Boolean			cmdRsrv2;		/* reserved for future use			*/
		Boolean			cmdRef1;		/* available for programmer use		*/
		unsigned char	text[32];		/* command code sequence characters	*/
	}; 
typedef	struct	ShortCommand		ShortCommand;
typedef	struct	ShortCommand *		SCmdPtr;
typedef struct	ShortCommand **		SCmdHndl;

struct LongCommand {		/* communication command code sequence instance	*/
		int				cmdID;			/* command type reference code ID	*/
		int				undoID;			/* cmd type ID for opposite, if any	*/
		Boolean			respond;		/* TRUE if response is expected		*/
		Boolean			synchronous;	/* TRUE if must wait for response	*/
		Boolean			onlyOnce;		/* TRUE if command not repeatable	*/
		Boolean			required;		/* TRUE if cmd must work completely	*/
		Boolean			hybrid;			/* both cmd ID refs and chars in cmd*/
										/* text. First IDs,0x00, then chars	*/
		Boolean			cmdRsrv1;		/* reserved for future use			*/
		Boolean			cmdRsrv2;		/* reserved for future use			*/
		Boolean			cmdRef1;		/* available for programmer use		*/
		unsigned char	text[256];		/* command code sequence characters	*/
	}; 
typedef	struct	LongCommand			LongCommand;
typedef	struct	LongCommand *		LCmdPtr;
typedef struct	LongCommand **		LCmdHndl;

struct CmdTable {			/* communications command sequence lookup table	*/
		long			tableInfo;		/* type,typelength & status of table*/ 
		long			cmdCount;		/* total command sequences in array	*/ 
		unsigned char	cmdSeq[1]; 		/* data size varies by cmd type,num	*/
	};									/* use SizeCmdTable() for bytelength*/ 
typedef	struct	CmdTable			CmdTable;
typedef	struct	CmdTable *			CmdTblPtr;
typedef struct	CmdTable **			CmdTblHndl;

struct TermData {				/* terminal emulation reference information	*/
		SerialPort		*commPort;		/* address of serialport data struct*/
		WindowPtr		commWindow;		/* communications window grafport	*/
										/* NULL if term display invisible	*/
		long			termType;	/* which model terminal being emulated	*/
		long			errors;		/* total errors since last reset		*/
		CmdTable		**cmdTbl;	/* terminal command lookup table		*/
		unsigned char	*charBuf[STD_ROWS];	/* pointers to ASCII char bufs	*/
		unsigned char	*atriBuf[STD_ROWS];	/* pointers to char attrib bufs	*/
		unsigned char	*statBuf[STD_STATROWS];	/* ptrs to status line bufs */
		Region			**updateRgn;	/* handle to term update region		*/
		int				visRows;	/* rows visible before line scrolls up	*/
		int				visCols;	/* cols active before wrap to next line	*/
		int				escFlag;	/* maintains status of command parsing	*/
		int				row;		/* row next character will appear on	*/
		int				col;		/* column next character will appear in	*/
		Rect			cursRect;	/* cursor size rectangle, NULL means off*/
		int				cursType;	/* cursor drawing mode & display pattern*/
		Boolean			echo;		/* TRUE if local character echo enabled	*/
		Boolean			ctrlKey;	/* TRUE if command, FALSE if modifiers	*/
									/* key used to enter control characters	*/
		Boolean			resizeFlg;
		Boolean			scrnFlg;
		Boolean			printFlg;
		Boolean			fileFlg4;
		Boolean			altFlg3;
		Boolean			modeFlg4;
		long			term1Ref;
		long			term2Ref;
	};
typedef	struct	TermData		TermData;
typedef	struct	TermData *		TermDPtr;
typedef struct	TermData **		TermDHndl;
	
#include	<extcommproto.h>

/* administrative routines which support ssg Commlib								*/

void		CommVersion();			/* return Pascal string of version #	*/

/* routines which support basic character IO in and out of a serial port	*/

Boolean		CheckPort();			/* handle data arriving at comm port	*/
/*OSErr		CommKey();				 for key down if comm window in front	*/
OSErr		SendChar();				/* put a character out the comm port	*/
OSErr		RecvChar();				/* get a character from the comm port	*/
OSErr		SendStr();				/* put a string out the comm port		*/
OSErr		RecvStr();				/* get a string from the comm port		*/

/* routines which support user changes to port and baud rate via menus	*/

void		StdCommMenus();			/* inits baud and serial port menus		*/
void 		HndlBaudMenu();			/* handles mouse down in baud rate menu	*/
SPortPtr 	HndlPortMenu();			/* handles mouse down serial port menu	*/

/* routines which support initialization and handling of serial port config */

OSErr		InitSPort();			/* initialize serial port and term emul */
OSErr		SetSPort();				/* set serial port attributes to values */
OSErr		SetBufSPort();			/* set serial port in/output buffers 	*/
void 		ResetSPort();			/* resets serial port driver for reuse	*/

/* routines which support windows and character display on screen	*/

TermData	*CrtTermWindow();		/* makes and inits a terminal window	*/
TermData	*GetTermData();			/* returns address of termdata record	*/
OSErr		SetTermData();			/* links termdata record to window		*/
void		InitTermData();			/* inits termdata record to defaults	*/
void		KillTerm();				/* destroys termdata, window, frees mem	*/
void		FlushTerm();			/* process all characters in IO buffers	*/
TermData	*BuildTerm();			/* makes term window from resource data	*/
OSErr		SaveTerm();				/* saves term window data to res fork	*/

/* routines which support terminal emulation and screen display functions 	*/

void		scrput();				/* output a character to the window 	*/
void		del_lin();				/* delete line primitive    			*/
void		ins_lin();				/* insert blank line primitive			*/
void		clr_eol();				/* clear to end of line primitive		*/
void		clr_bol();				/* clear from beginning of line to curs	*/
void		clr_lin();				/* clear entire line cursor is on		*/
void		clr_eos();				/* clear to end of screen primitive		*/
void		clr_bos();				/* clear from beginning of screen prim	*/
void		clr_screen();			/* clear entire screen primitive		*/
void		ins_char();				/* insert character primitive			*/
void		del_char();				/* delete character primitive    		*/
void		putln();				/* put line to screen primitive			*/
void		getln();				/* get line from keyboard primitive		*/
void		up_cursor();			/* move cursor up one line primitive	*/
void		down_cursor();			/* move cursor down one line primitive	*/
void		right_cursor();			/* move cursor one character to right	*/
void		left_cursor();			/* move cursor one character to left	*/
void		xy_cursor();			/* position cursor to absolute xy coord	*/
OSErr		save_cursor();			/* save cursor information for later	*/
OSErr		rstr_cursor();			/* restore cursor information 			*/
OSErr		curs_position();		/* reports current cursor row & column	*/
OSErr		curs_home();			/* puts cursor in upper left corner		*/
OSErr		term_id();				/* reports terminal idenitification info*/
OSErr		term_reset();			/* resets terminal status to defaults	*/

/* routines which support error free file transfer between computers	*/

OSErr		SendFile();				/* transfers file using protocol asked	*/
OSErr		RecvFile();				/* receives file using protocol asked	*/

OSErr		XM_SendFile();			/* transfers file using XModem protocol	*/
OSErr		XM_RecvFile();			/* receives file using XModem protocol	*/
OSErr		XM_Trans();				/* transmission executive routine		*/
OSErr		XM_Block();				/* sends next packet/block of data		*/
OSErr		XM_BName();				/* sends file name remote in batch mode	*/

OSErr		MB_SendFile();			/* sends file using MacBinary protocol	*/
OSErr		MB_RecvFile();			/* receives file using MacBinary prot.	*/
OSErr		MB_Trans();				/* transmission executive routine		*/
OSErr		MB_Block();				/* sends next packet/block of data		*/
OSErr		MB_BName();				/* sends file name, type info to remote	*/

OSErr		KT_SendFile();			/* sends file using Kermit protocol		*/
OSErr		KT_RecvFile();			/* receives file using Kermit protocol	*/
OSErr		KT_Trans();				/* transmission executive routine		*/
OSErr		KT_Block();				/* sends next packet/block of data		*/
OSErr		KT_BName();				/* sends file name remote in batch mode	*/
