/*						* Commlib library header *								*/
/*						  ssg Commlib											*/

/*		Copyright  1986,1987 by small systems guild.  All rights reserved.		*/

/*			Written to compile under Lightspeed C version 2.01					*/
/*					and under Lightspeed C version 2.01							*/

/* administrative routines which support small systems guild Commlib			*/

void		CommVersion(char *);	/* return Pascal string of version #	*/

/* routines which support basic character IO in and out of a serial port	*/

Boolean		CheckPort(TermData *);	/* handle data arriving at comm port	*/
/*OSErr		CommKey(WindowPtr,char,int);			for key down if comm window in front	*/
OSErr		SendChar(SerialPort *,char);	/* put char out the comm port	*/
OSErr		RecvChar(SerialPort *,char *);	/* get char from the comm port	*/
OSErr		SendStr(SerialPort *,char *);	/* put string out comm port		*/
OSErr		RecvStr(SerialPort *,char *);	/* get string from comm port		*/

/* routines which support user changes to port and baud rate via menus	*/

void		StdCommMenus(MenuHandle *,MenuHandle *);/*init baud,serial port menua*/
void 		HndlBaudMenu();			/* handles mouse down in baud rate menu	*/
SPortPtr 	HndlPortMenu();			/* handles mouse down serial port menu	*/

/* routines which support initialization and handling of serial port config */

OSErr		InitSPort(SerialPort *,char);/* initialize serial port/term emul*/
OSErr		SetSPort(SerialPort *);	/* set serial port attributes to values */
OSErr		SetBufSPort(SerialPort *);/* set serial port in/output buffers 	*/
void 		ResetSPort(SerialPort *);/* resets serial port driver for reuse	*/

/* routines which support windows and character display on screen	*/

TermData	*CrtTermWindow(WindowPtr);/* makes and inits a terminal window	*/
TermData	*GetTermData(WindowPtr);/* returns address of termdata 			*/
OSErr		SetTermData(WindowPtr,TermData *);	/* links termdata, window		*/
void		InitTermData(TermData *);/* inits termdata record to defaults	*/
void		KillTerm(TermData *);	/* destroys termdata, window, frees mem	*/
void		FlushTerm(TermData *);	/* process all characters in IO buffers	*/
TermData	*BuildTerm(int);		/* makes term window from resource data	*/
OSErr		SaveTerm(TermData *,int);/* saves term window data to res fork	*/

/* routines which support terminal emulation and screen display functions 	*/

void		scrput(TermData *,char);/* output a character to the window 	*/
void		del_lin(TermData *,int);/* delete line primitive    			*/
void		ins_lin(TermData *,int);/* insert blank line primitive			*/
void		clr_eol(TermData *);	/* clear to end of line primitive		*/
void		clr_bol(TermData *);	/* clear from beginning of line to curs	*/
void		clr_lin(TermData *);	/* clear entire line cursor is on		*/
void		clr_eos(TermData *);	/* clear to end of screen primitive		*/
void		clr_bos(TermData *);	/* clear from beginning of screen prim	*/
void		clr_screen(TermData *);	/* clear entire screen primitive		*/
void		ins_char(TermData *);	/* insert character primitive			*/
void		del_char(TermData *);	/* delete character primitive    		*/
void		putln(TermData *);		/* put line to screen primitive			*/
void		getln(TermData *);		/* get line from keyboard primitive		*/
void		up_cursor(TermData *);	/* move cursor up one line primitive	*/
void		down_cursor(TermData *);/* move cursor down one line primitive	*/
void		right_cursor(TermData *);/* move cursor one character to right	*/
void		left_cursor(TermData *);/* move cursor one character to left	*/
void		xy_cursor(TermData *);	/* position cursor to absolute xy coord	*/
OSErr		save_cursor(TermData *);/* save cursor information for later	*/
OSErr		rstr_cursor(TermData *);/* restore cursor information 			*/
OSErr		curs_position(TermData *);/* reports current cursor row & column	*/
OSErr		curs_home(TermData *);	/* puts cursor in upper left corner		*/
OSErr		term_id(TermData *);	/* reports terminal idenitification info*/
OSErr		term_reset(TermData *);	/* resets terminal status to defaults	*/

/* routines which support error free file transfer between computers	*/

OSErr		SendFile(TermData *,SFReply *,int,Boolean);	/* transfers file 	*/
OSErr		RecvFile(TermData *,SFReply *,int,Boolean);	/* receives file 	*/

OSErr		XM_SendFile(TermData *,SFReply *,Boolean);	/* transfers using XModem	*/
OSErr		XM_RecvFile(TermData *,SFReply *,Boolean);	/* receives using XModem	*/
OSErr		XM_Trans(TermData *,int);	/* transmission executive routine		*/
OSErr		XM_Block(TermData *,int);	/* sends next packet/block of data		*/
OSErr		XM_BName(TermData *,int);	/* sends file name remote in batch mode	*/

OSErr		MB_SendFile(TermData *,SFReply *,Boolean);	/* sends using MacBinary	*/
OSErr		MB_RecvFile(TermData *,SFReply *,Boolean);	/* receives using MacBinary	*/
OSErr		MB_Trans(TermData *,int);	/* transmission executive routine		*/
OSErr		MB_Block(TermData *,int);	/* sends next packet/block of data		*/
OSErr		MB_BName(TermData *,int);	/* sends file name, type info to remote	*/

OSErr		KT_SendFile(TermData *,SFReply *,Boolean);	/* sends using Kermit		*/
OSErr		KT_RecvFile(TermData *,SFReply *,Boolean);	/* receives using Kermit	*/
OSErr		KT_Trans(TermData *,int);	/* transmission executive routine		*/
OSErr		KT_Block(TermData *,int);	/* sends next packet/block of data		*/
OSErr		KT_BName(TermData *,int);	/* sends file name remote in batch mode	*/
