/*					 small systems guild communication library					*/
/*							 ext.h - version 1.0b - 11/16/87							*/

/*					Written to compile under Aztec C version 3.4b, 				*/
/*					 	MPW / Greenhills C version 2.0B1 							*/
/*					   	and Lightspeed C version 2.11.							*/

/*			Based on Invention Software Programmer's Extender Volume 1		*/
/*					for compatability with Invention Software's					*/
/*						  			Programmer's Extender								*/

#define LIGHTSPEED			/* if using LightspeedC 2.11 compiler			*/
/* #define MPWGC			*/	/* if using MPW Greenhills C 2.0B1 compiler	*/
/* #define AZTEC			*/	/* if using Aztec C 3.4b compiler				*/

#ifdef AZTEC

#include <Quickdraw.h>
#include <Menus.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Events.h>
#include <Desk.h>
#include <Controls.h>
#include <Resources.h>
#include <Fonts.h>
#include <Dialogs.h>
#include <Packages.h>
#include <Memory.h>
#include <OSUtils.h>
#include <Errors.h>
#include <Scrap.h>
#include <ToolUtils.h>
#include <Files.h>

#define  fRefNum			ioFRefNum		/* for the compatability of the code	*/
#define	RETURN			return()


#define	inZoomIn			7
#define	inZoomOut		8

#else
#ifdef LIGHTSPEED

#include <QuickDraw.h>
#include <MenuMgr.h>
#include <WindowMgr.h>
#include <TextEdit.h>
#include <EventMgr.h>
#include <DeskMgr.h>
#include <ControlMgr.h>
#include <ResourceMgr.h>
#include <FontMgr.h>
#include <DialogMgr.h>
#include <PackageMgr.h>
#include <MemoryMgr.h>
#include <OSUtil.h>
#include <ToolboxUtil.h>
#include <FileMgr.h>
#include <StdFilePkg.h>
#include <ScrapMgr.h>
#include <DeviceMgr.h>
#include <xControlMgr.h>
#include <xDeskBus.h>
#include <xDialogMgr.h>
#include <xMenuMgr.h>
#include <xQuickDraw.h>
#include <xResourceMgr.h>
#include <xTextEdit.h>
#include <xWindowMgr.h>
#include <xStartMgr.h>

#define RETURN			return
#define pass(A)		(A)

#else
#ifdef MPWGC

#include <Types.h>
#include <Resources.h>
#include <Quickdraw.h>
#include <Windows.h>
#include <OSUtils.h>
#include <Controls.h>
#include <Menus.h>
#include <Desk.h>
#include <CType.h>
#include <Devices.h>
#include <Dialogs.h>
#include <DiskInit.h>
#include <Disks.h>
#include <ErrNo.h>
#include <Errors.h>
#include <Events.h>
#include <FCntl.h>
#include <Files.h>
#include <Fonts.h>
#include <IOCtl.h>
#include <Memory.h>
#include <OSEvents.h>
#include <Packages.h>
#include <Perf.h>
#include <ROMDefs.h>
#include <Scrap.h>
#include <SegLoad.h>
#include <Serial.h>
#include <Start.h>
#include <StdIO.h>
#include <String.h>
#include <Strings.h>
#include <TextEdit.h>
#include <Time.h>
#include <ToolUtils.h>
#include <Values.h>
#include <VarArgs.h>

#define TRUE			(Boolean)1
#define FALSE			(Boolean)0

#define RETURN			return
#define pass(A)		(&(A))

#endif
#endif
#endif

#ifndef NULL						/* if NULL has not been defined 		*/
#define NULL		0L				/* 32 bit 0 or hex 0x00000000 		*/
#endif

#define NEG_ONE	(-1L)			/* 32 bit -1 or hex 0xFFFFFFFF 		*/

#define SYNC1VAL	((unsigned long)72954)	/* WData structure validation codes	*/
#define SYNC2VAL	((unsigned long)52878)

struct WData {
			PicHandle		windowPic;			/* QuickDraw picture assoc w/window	*/
			TEHandle			TEH;					/* TextEdit record assoc w/window	*/
			Handle			wList;				/* List Manager: Extender volume II	*/
			ControlHandle	vScrollBar,hScrollBar;		/* horizontal, vertical		*/
			Boolean			GrowBox;				/* resizeable box in window corner	*/
			unsigned long	exceptFlags;		/* event handling exception bitflags*/
			unsigned long	sync1,sync2;		/* synchronization validation codes	*/
			unsigned long	rsrv1,rsrv2,rsrv3,rsrv4; /* reserved for future use	*/
			unsigned long	UsrRef1,UsrRef2;	/* for programmer use as you wish	*/
		};
typedef struct WData		WData;
typedef struct WData *		WDPtr;
typedef struct WData **		WDHandle;

struct EventStuff {
			WindowPtr		WhichWindow;
			int				WindowPart;
			DialogPtr		WhichDialog;
			int				DialogItem;
			ControlHandle	WhichControl;
			int				ControlPart;
			Handle			WhichList;
			Point				WhichCell;
			int				ListPart;
			MenuHandle		MenuH;
			int				MenuNum;
			int				ItemNum;
			TEHandle			TEH;
			char				ch;
			EventRecord		NewMouseDown;
			EventRecord		LastMouseDown;
			Boolean			SizeChanged;
			Boolean			WindowIsNew;
			Boolean			DoubleClick;
			Boolean			DialogEvent;
			Handle			HRsrv1,HRsrv2;
			int				IRsrv1,IRsrv2;
};
typedef struct EventStuff		EventStuff;
typedef struct EventStuff *	ESPtr;
typedef struct EventStuff **	ESHandle;

#ifdef AZTEC
	#include "extRoutines.h"
#else
#ifdef MPWGC
	#include "extRoutines.h"
#else
#ifdef LIGHTSPEED
	#include "extProto.h"
#endif
#endif
#endif
